#include <stdio.h>
#include <stdlib.h>
#include <SDL/SDL.h>
#include "types.h"

#define SCREEN_WIDTH    320
#define SCREEN_HEIGHT   200
#define TITLE           "Polygon_chap38"

static SDL_Surface* scr;

/* Draws the pixel at (X,Y) in colour Colour */
void DrawPixel(S32 X, S32 Y, S32 Colour)
{
  color_type ColourUsed;     
       
  switch(Colour)
  {
      /* black */          
      case 0:
          ColourUsed.r = 0;
          ColourUsed.g = 0;
          ColourUsed.b = 0;
      break;          
                
      /* Blue */
      case 1:
           ColourUsed.r = 0;
           ColourUsed.g = 0;
           ColourUsed.b = 170;
      break;
                
      /* Green  */          
      case 2:
           ColourUsed.r = 0;
           ColourUsed.g = 170;
           ColourUsed.b = 0;
      break;
      
      /* cyan */          
      case 3:
          ColourUsed.r = 0;
          ColourUsed.g = 170;
          ColourUsed.b = 170;
      break;
      
      /* Red  */     
      case 4: 
          ColourUsed.r = 170;
          ColourUsed.g = 0;
          ColourUsed.b = 0;        
      break;
      
       /* MAGENTA  */     
      case 5: 
          ColourUsed.r = 170;
          ColourUsed.g = 0;
          ColourUsed.b = 170;        
      break;     
                  
      /* brown */
      case 6:
          ColourUsed.r = 170;
          ColourUsed.g = 85;
          ColourUsed.b = 0;
      break;
      
      /* LIGHT GRAY */
      case 7:
          ColourUsed.r = 170;
          ColourUsed.g = 170;
          ColourUsed.b = 170;
      break;
      
      /* black */
      case 40:
          ColourUsed.r = 0;
          ColourUsed.g = 0;
          ColourUsed.b = 0;
      break;
      
      default:
          /* do nothing */
      break;                             
  }
          
       
  U32 colorSDL = SDL_MapRGB(scr->format, ColourUsed.r, ColourUsed.g,ColourUsed.b);
  U32* bufp;

  bufp = (U32*)scr->pixels + Y * scr->pitch / 4 + X;

  *bufp = colorSDL;
}

/* 
================================================================
=
= Function: redraw
=
= Description:
=
= Updates the screen.  Has to be called to view new pixels, 
= but use only after drawing the whole screen because it's slow.
=
================================================================
*/
void redraw(void)
{
  SDL_UpdateRect(scr, 0, 0, 0, 0);
}

/* 
================================================================
=
= Function: cls
=
= Description:
=
= Clears the screen to black
=
================================================================
*/
void cls(void)
{
  SDL_FillRect(scr, NULL, 0);
}

/* 
================================================================
=
= Function: InitSDLScreenBuf
=
= Description:
=
= Try and get a handle to the screen buffer
=
================================================================
*/
U8 InitSDLScreenBuf(void)
{
    S32 Width = SCREEN_WIDTH;
    S32 Height = SCREEN_HEIGHT;
    S32 ColorDepth = 32;

     /* use SDL lib to get access to screen buffer */
    if(SDL_Init(SDL_INIT_EVERYTHING) < 0)
    {
        printf("Unable to init SDL: %s\n", SDL_GetError());
        SDL_Quit();
        return(1);
    }

    SDL_WM_SetCaption(TITLE, NULL);

    scr = SDL_SetVideoMode(Width, Height, ColorDepth, SDL_HWSURFACE | SDL_HWPALETTE);

    if(scr == NULL)
    {
        printf("Unable to set video: %s\n", SDL_GetError());
        SDL_Quit();
        return(1);
    }

    return(0);
}
